#!/usr/bin/perl

use Getopt::Std;

getopt("i", \%args);

#Set input variables

$model = $args{i} || "all.out";
$model =~ s/\s+$//; $model =~ s/^\s+//;

print STDERR "Opening $model file for RNA...\n";
open (MODEL, "< $model") || die ("Cannot open namot file, $model!\n");

$bad=0;
$okay=0;
$poss=0;
$total=0;

while (defined($line = <MODEL>)) {
   @chunks = split('\t',$line); 
   $type = $chunks[3];
   $type =~ s/\s+$//; $type =~ s/^\s+//;
   if($chunks[0] ne 'number_' && $chunks[2] ne '_' && 
      ($type eq 'CYT' || $type eq 'URI' || 
      $type eq 'GUA' || $type eq 'ADE')) {
      $total++;
      $num= $chunks[13];
      $num =~ s/\s+$//; $num =~ s/^\s+//;
      if($num eq 'bad') {
         $bad++;
      } elsif($num eq '[OK]') {
         $okay++;
      } elsif($num eq 'possible') {
         $poss++;
      }
   }
}
if($total != 0) {
   print STDOUT "$model\t$total\t$okay\t$poss\t$bad\t";
   print STDOUT int($okay*100/$total)."\%\t".int($poss*100/$total)
	."\%\t".int($bad*100/$total)."\%\n";
   print STDERR int($okay*100/$total)."\%\t".int($poss*100/$total)
	."\%\t".int($bad*100/$total)."\%\n";
}
close(MODEL);
